"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = factory;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _compression = _interopRequireDefault(require("compression"));

var _cookieParser = _interopRequireDefault(require("cookie-parser"));

var _express = _interopRequireDefault(require("express"));

var _serveFavicon = _interopRequireDefault(require("serve-favicon"));

var _helmet = _interopRequireDefault(require("helmet"));

var _morgan = _interopRequireDefault(require("morgan"));

var _requestIp = _interopRequireDefault(require("request-ip"));

var _stream = _interopRequireDefault(require("stream"));

var _renderer = _interopRequireDefault(require("./renderer"));

/**
 * Creation of standard ExpressJS server for ReactJS apps.
 */
function factory(_x, _x2) {
  return _factory.apply(this, arguments);
}

function _factory() {
  _factory = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(webpackConfig, options) {
    var renderer, publicPath, server, FORMAT, webpack, webpackDevMiddleware, webpackHotMiddleware, compiler;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            renderer = (0, _renderer.default)(webpackConfig, options);
            publicPath = webpackConfig.output.publicPath;
            server = (0, _express.default)();
            server.use((0, _compression.default)());
            server.use((0, _helmet.default)());

            if (options.favicon) {
              server.use((0, _serveFavicon.default)(options.favicon));
            }

            server.use('/robots.txt', function (req, res) {
              return res.send('User-agent: *\nDisallow:');
            });
            server.use(_bodyParser.default.json({
              limit: '300kb'
            }));
            server.use(_bodyParser.default.urlencoded({
              extended: false
            }));
            server.use((0, _cookieParser.default)());
            server.use(_requestIp.default.mw());

            _morgan.default.token('ip', function (req) {
              return req.clientIp;
            });

            FORMAT = ':ip > :status :method :url :response-time ms :res[content-length] :referrer :user-agent';
            server.use((0, _morgan.default)(FORMAT, {
              stream: new _stream.default.Writable({
                decodeStrings: false,
                write: function write(chunk, encoding, cb) {
                  options.logger.log(chunk);
                  cb();
                }
              })
            }));
            /* Ensures no caching for the service worker script. */

            server.use("".concat(publicPath, "service-worker.js"), function (req, res, next) {
              res.header('Cache-Control', 'no-cache');
              next();
            });
            /* Setup of Hot Module Reloading for development environment.
             * These dependencies are not used, nor installed for production use,
             * hence we should violate some import-related lint rules. */

            /* eslint-disable global-require */

            /* eslint-disable import/no-extraneous-dependencies */

            /* eslint-disable import/no-unresolved */

            if (options.devMode) {
              webpack = require('webpack');
              webpackDevMiddleware = require('webpack-dev-middleware');
              webpackHotMiddleware = require('webpack-hot-middleware');
              compiler = webpack(webpackConfig);
              compiler.apply(new webpack.ProgressPlugin());
              server.use(webpackDevMiddleware(compiler, {
                name: 'main.js',
                publicPath: publicPath,
                serverSideRender: true
              }));
              server.use(webpackHotMiddleware(compiler));
            }
            /* eslint-enable global-require */

            /* eslint-enable import/no-extraneous-dependencies */

            /* eslint-enable import/no-unresolved */


            server.use(publicPath, _express.default.static(webpackConfig.output.path));

            if (!options.onExpressJsSetup) {
              _context.next = 20;
              break;
            }

            _context.next = 20;
            return options.onExpressJsSetup(server);

          case 20:
            server.use(renderer);
            /* Detects 404 errors, and forwards them to the error handler. */

            server.use(function (req, res, next) {
              var err = new Error('Not Found');
              err.status = 404;
              next(err);
            });
            /* Error handler. */

            server.use(function (err, req, res, next) {
              // eslint-disable-line no-unused-vars
              var errorResponse = null;
              var status = err.isJoi ? 400 : err.httpStatus || err.status || 500;

              if (err.isJoi && _lodash.default.isArray(err.details)) {
                _lodash.default.map(err.details, function (e) {
                  if (e.message) {
                    if (!errorResponse) errorResponse = e.message;else errorResponse += ", ".concat(e.message);
                  }
                });
              }

              errorResponse = errorResponse || err.message || 'Internal Server Error';
              /* Sets locals. The actual errors are exposed only in dev. */

              _lodash.default.assign(res, {
                locals: {
                  error: req.app.get('env') === 'development' ? err : {},
                  message: err.message
                }
              });
              /* Finally, the error response. */


              res.status(status).send(errorResponse);
            });
            return _context.abrupt("return", server);

          case 24:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _factory.apply(this, arguments);
}