"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findInDomByClass = findInDomByClass;
exports.findInDomManyByClass = findInDomManyByClass;
exports.render = render;
exports.renderDom = renderDom;
exports.shallowRender = shallowRender;
exports.shallowSnapshot = shallowSnapshot;
exports.snapshot = snapshot;
exports.simulate = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

var _shallow = _interopRequireDefault(require("react-test-renderer/shallow"));

/**
 * Utilities for Jest tests.
 */

/* NOTE: At the moment here is no intention to use this module for runtime
 * execution, only for tests; thus we depend on Jest environment and dev
 * dependencies. */

/* global expect */

/* eslint-disable import/no-extraneous-dependencies */

/* eslint-enable import/no-extraneous-dependencies */

/**
 * Just an alias for TU.findRenderedDOMComponentWithClass(..).
 * @param {Object} dom
 * @param {String} className
 * @return {Object}
 */
function findInDomByClass(dom, className) {
  return _testUtils.default.findRenderedDOMComponentWithClass(dom, className);
}
/**
 * Just an alias for TU.scryRenderedDOMComponentsWithClass(..).
 * @param {Object} dom
 * @param {Stirng} className
 * @return {Array}
 */


function findInDomManyByClass(dom, className) {
  return _testUtils.default.scryRenderedDOMComponentsWithClass(dom, className);
}
/**
 * Auxiliary wrapper around ReactJS Test Renderer.
 * @param {Object} component ReactJS component to render.
 * @return {Object} JSON representation of the rendered tree.
 */


function render(component) {
  return _reactTestRenderer.default.create(component).toJSON();
}
/* The Wrapper is necessary for the "renderDom(..)" function, because
 * the "renderIntoDocument(..)" function from "react-dom/test-utils" works
 * only with state components, so we have to wrap our ReactJS components into
 * such Wrapper. */


var Wrapper =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Wrapper, _React$Component);

  function Wrapper() {
    (0, _classCallCheck2.default)(this, Wrapper);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Wrapper).apply(this, arguments));
  }

  (0, _createClass2.default)(Wrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      return children;
    }
  }]);
  return Wrapper;
}(_react.default.Component);

Wrapper.propTypes = {
  children: _propTypes.default.node.isRequired
};
/**
 * Renders given component into DOM, using "react-dom/test-utils".
 * @param {Object} component ReactJS component to render.
 * @return {Object} Rendered DOM.
 */

function renderDom(component) {
  return _testUtils.default.renderIntoDocument(_react.default.createElement(Wrapper, null, component));
}
/**
 * Auxiliary wrapper around ReactJS Shallow Test Renderer.
 * @param {Object} component ReactJS component to render.
 * @return {Object} JSON representation of the shallow component's render tree.
 */


function shallowRender(component) {
  var renderer = new _shallow.default();
  renderer.render(component);
  return renderer.getRenderOutput();
}
/**
 * Renders provided ReactJS component with ReactJS Shallow Test Renderer,
 * creates/tests its snapshot, and returns the render result.
 * @param {Object} component ReactJS component to render.
 * @return {Object} JSON representation of shallow render.
 */


function shallowSnapshot(component) {
  var res = shallowRender(component);
  expect(res).toMatchSnapshot();
  return res;
}
/**
 * Renders provided ReactJS component with ReactJS Test Renderer,
 * creates/tests the snapshot, and returns the render.
 * @param {Object} component ReactJS component to render.
 * @return {Object} JSON render of the component.
 */


function snapshot(component) {
  var res = render(component);
  expect(res).toMatchSnapshot();
  return res;
}

var simulate = _testUtils.default.Simulate;
exports.simulate = simulate;
