"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _nodeForge = _interopRequireDefault(require("node-forge"));

/**
 * Initialization of client-side environment.
 */

/* global BUILD_INFO, document, window */
window.TRU_BUILD_INFO = BUILD_INFO;
window.TRU_FRONT_END = true;
/* Removes data injection script out of the document. */

var block = document.querySelector('script[id="inj"]');
document.getElementsByTagName('body')[0].removeChild(block);
/* TODO: A proper logger should be moved to `topcoder-react-utils`. */

/* eslint-disable no-console */

var useServiceWorker = window.TRU_BUILD_INFO.useServiceWorker;

if (useServiceWorker) {
  var _window = window,
      navigator = _window.navigator;

  if ('serviceWorker' in navigator) {
    window.addEventListener('load',
    /*#__PURE__*/
    (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      var reg;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return navigator.serviceWorker.register('/__service-worker.js');

            case 3:
              reg = _context.sent;
              console.log('SW registered:', reg);
              _context.next = 10;
              break;

            case 7:
              _context.prev = 7;
              _context.t0 = _context["catch"](0);
              console.log('SW registration failed:', _context.t0);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[0, 7]]);
    })));
  }
}
/* eslint-enable no-console */

/* Decodes data injected at the server side. */


var key = window.TRU_BUILD_INFO.key;

var data = _nodeForge.default.util.decode64(window.INJ);

var decipher = _nodeForge.default.cipher.createDecipher('AES-CBC', key);

decipher.start({
  iv: data.slice(0, 32)
});
decipher.update(_nodeForge.default.util.createBuffer(data.slice(32)));
decipher.finish();
data = JSON.parse(_nodeForge.default.util.decodeUtf8(decipher.output.data));
window.CONFIG = data.CONFIG;
window.ISTATE = data.ISTATE;
